#ifndef DESKBAR_ADDON_MANAGER_H
#define DESKBAR_ADDON_MANAGER_H

struct DeskbarItemInfo {
	bool isaddon;
	int32 id;
	dev_t edevice;
	ino_t edirectory;
	char *ename;
	node_ref nref;
	dev_t realDevice;
};

class TDeskbarAddonManager
{
public:
	TDeskbarAddonManager();
	virtual ~TDeskbarAddonManager();

	status_t LoaddAddOn( BEntry *entry, int32 *id, bool force =false );

protected:

	void InitAddOnSupport();
	void DeleteAddOnSupport();
	void RunAddOnQuery( BVolume *volume, const char *predicated );

	bool IsAddOn(entry_ref *ref);
	bool NodeExists(node_ref *);

	void HandleEntryUpdate(BMessage *);
	status_t AddItem(int32 id, node_ref nref, BEntry *entry, bool isAddon );

	void UnloadAddOn(node_ref *, dev_t *, bool which, bool removeAll );
	void RemoveItem(int32 id);

	void MoveItem(entry_ref *, ino_t toDirectory, ino_t node);

	BList *fItemList;
	uint64 fDeskbarSecurityCode;
};

#endif
