/*
{some nifty licence stuff here}
copyright by Daniel T. Bender aka "HarvestMoon", 2002
mail to
	daniel@black-karma.de
	h4rv3st@web.de
	
Black Karma - http://www.black-karma.de
*/

#include "PWindow.h"

PWindow::PWindow(BRect frame)
: BWindow(frame, "DockBert Preferences", B_TITLED_WINDOW, B_NOT_ZOOMABLE | B_NOT_RESIZABLE, B_CURRENT_WORKSPACE)
{
	//SetLook((window_look)25);
	BScreen *screen = new BScreen(B_MAIN_SCREEN_ID);
	BRect screen_rect = screen -> Frame();
	
	MoveTo(screen_rect.Width()/2 - frame.Width()/2, screen_rect.Height()/2 - frame.Height()/2);
	
	BRect bounds = Bounds();
	tabview = new BTabView(bounds, "background tabview");
	AddChild(tabview);
	
	BRect tab_bounds = tabview -> Bounds();
	tab_bounds.bottom -= tabview -> TabHeight();
	// ##############################################
	// # getting the MessageLoop of the Dock window #
	// ##############################################
	
	// ########
	// # dock #
	// ########
	box_dock = new BBox(tab_bounds, "dock-tab", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS, B_NO_BORDER);
	tab_dock = new BTab();
	
	dockautohide = new BCheckBox(BRect(10, 10, 75, 0), "", "Auto-Hide", new BMessage(DOCK_AUTO_HIDE), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_dock -> AddChild(dockautohide);
	
	dockdelaytime = new BSlider(BRect(10, 35, 110, 0), "delay time slider", "Delay (seconds)", new BMessage(DOCK_DELAY_TIME), 0, 25, B_TRIANGLE_THUMB, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE);
	dockdelaytime -> SetHashMarks(B_HASH_MARKS_BOTTOM);
	dockdelaytime -> SetHashMarkCount(6);
	dockdelaytime -> SetLimitLabels("0", "5");
	dockdelaytime -> SetEnabled(false);
	box_dock -> AddChild(dockdelaytime);
	
	BBox *dockcolorbox;
	BRect dockcolorbounds = box_dock -> Bounds();
	dockcolorbounds.InsetBy(10, 10);
	dockcolorbounds.left += 110;
	dockcolorbounds.bottom = dockcolorbounds.top + 60 - 3;
	dockcolorbox = new BBox(dockcolorbounds, "", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_FRAME_EVENTS, B_FANCY_BORDER);
	box_dock -> AddChild(dockcolorbox);
	
	dockcolorctrl = new BColorControl(BPoint(2, 2), B_CELLS_32x8, 1, "", new BMessage(DOCK_COLOR), false);
	dockcolorbox -> AddChild(dockcolorctrl);
	
	dockpostop = new BRadioButton(BRect(10, 100, 100, 0), "", "Top", new BMessage(DOCK_POSITION_TOP), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	dockposbottom = new BRadioButton(BRect(10, 125, 100, 0), "", "Bottom", new BMessage(DOCK_POSITION_BOTTOM), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	dockposleft = new BRadioButton(BRect(10, 150, 100, 0), "", "Left", new BMessage(DOCK_POSITION_LEFT), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	dockposright = new BRadioButton(BRect(10, 175, 100, 0), "", "Right", new BMessage(DOCK_POSITION_RIGHT), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	
	box_dock -> AddChild(dockpostop);
	box_dock -> AddChild(dockposleft);
	box_dock -> AddChild(dockposright);
	box_dock -> AddChild(dockposbottom);
	
	docktransparentmenus = new BCheckBox(BRect(130, 200, 250, 0), "", "Transparent Menus", new BMessage(DOCK_TRANSPARENT_MENUS), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	//box_dock -> AddChild(docktransparentmenus);
	
	dockdrawouterframe = new BCheckBox(BRect(130, 150, 250, 0), "", "Draw outer Frame", new BMessage(DOCK_DRAW_OUTER_FRAME), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_dock -> AddChild(dockdrawouterframe);
	
	dockalwaysontop = new BCheckBox(BRect(130, 100, 250, 0), "", "Always on top", new BMessage(DOCK_ALWAYS_ON_TOP), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_dock -> AddChild(dockalwaysontop);

	dockhidestddeskbar = new BCheckBox(BRect(130, 125, 300, 0), "", "Hide Standard Deskbar", new BMessage(DOCK_HIDE_STD_DESKBAR), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_dock -> AddChild(dockhidestddeskbar);

	dockusewindowshapping = new BCheckBox(BRect(130, 175, 350, 0), "", "Use Window Shapping (R5.1d0 only)", new BMessage(DOCK_USE_WINDOW_SHAPPING), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	#ifdef B_BEOS_VERSION_DANO
		box_dock -> AddChild(dockusewindowshapping);
	#endif

	tabview -> AddTab(box_dock, tab_dock);
	tab_dock -> SetLabel("Dock");
	
	// ########
	// # tabs #
	// ########
	box_tabs = new BBox(tab_bounds, "tabs-tab", B_FOLLOW_ALL, B_WILL_DRAW | B_FRAME_EVENTS, B_NO_BORDER);
	tab_tabs = new BTab();
	
	BRect tablistbounds = box_tabs -> Bounds();
	tablistbounds.top += 10 + 30;
	tablistbounds.left += 10;
	tablistbounds.right = tablistbounds.left + 85;
	tablistbounds.bottom -= 10;
	
	tablistscrollview = new BScrollView("scrollview", tablistview = new BListView(tablistbounds, "listview", B_SINGLE_SELECTION_LIST, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE | B_FRAME_EVENTS), B_FOLLOW_LEFT | B_FOLLOW_TOP, 0, false, true, B_FANCY_BORDER);
	tablistview -> SetInvocationMessage(new BMessage(TAB_LISTITEM_INVOKED));
	tablistview -> SetSelectionMessage(new BMessage(TAB_LISTITEM_SELECTED));
	box_tabs -> AddChild(tablistscrollview);
	
	BBox *tabcolorbox;
	BRect tabcolorbounds = box_tabs -> Bounds();
	tabcolorbounds.InsetBy(10, 10);
	tabcolorbounds.left += 110;
	tabcolorbounds.bottom = tabcolorbounds.top + 60 - 3;
	tabcolorbox = new BBox(tabcolorbounds, "", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_FRAME_EVENTS, B_FANCY_BORDER);
	box_tabs -> AddChild(tabcolorbox);
	
	tabcolorctrl = new BColorControl(BPoint(2, 2), B_CELLS_32x8, 1, "", new BMessage(TAB_COLOR), false);
	tabcolorbox -> AddChild(tabcolorctrl);
	tabcolorctrl -> SetEnabled(false);

	
	tabtextentry = new BTextControl(BRect(120, 75, 300, 250), "", "Tab Name", "", new BMessage(TAB_NAME_CHANGED), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	tabtextentry -> SetDivider(50);
	tabtextentry -> SetEnabled(false);
	box_tabs -> AddChild(tabtextentry);

	tabautohide = new BCheckBox(BRect(120, 150, 300, 0), "", "Tab Auto-Hide", new BMessage(TAB_AUTO_HIDE), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	tabautohide -> SetEnabled(false);
	//box_tabs -> AddChild(tabautohide);
	
	tabcpuusagebar = new BCheckBox(BRect(120, 100, 300, 0), "", "CPU Usage Bars", new BMessage(TAB_CPU_USAGE_BAR), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	tabcpuusagebar -> SetEnabled(false);
	box_tabs -> AddChild(tabcpuusagebar);
	
	tabalphahandles = new BCheckBox(BRect(120, 125, 300, 0), "", "Use Alpha blended ActiveHandles", new BMessage(TAB_ALPHA_HANDLES), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	tabalphahandles -> SetEnabled(false);
	box_tabs -> AddChild(tabalphahandles);
	
	tabsamecolor = new BCheckBox(BRect(120, 200, 300, 0), "", "All Tabs same color", new BMessage(TAB_SAME_COLOR), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_tabs -> AddChild(tabsamecolor);
	
	new_tab = new BButton(BRect(10, 10, 60, 30), "", "Create", new BMessage(TAB_CREATE_TAB), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_tabs -> AddChild(new_tab);
	
	remove_tab = new BButton(BRect(60, 10, 110, 30), "", "Delete", new BMessage(TAB_REMOVE_TAB), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	box_tabs -> AddChild(remove_tab);
	remove_tab -> SetEnabled(false);
	
	tabview -> AddTab(box_tabs, tab_tabs);
	tab_tabs -> SetLabel("Tabs");

/*
	{
		BAlert *myAlert = new BAlert("Error", "Sorry, dude.\nNo valid Deskbar found!", "Bummer", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT);
		myAlert->SetShortcut(0, B_ESCAPE); 
		myAlert->Go();
		PostMessage(B_QUIT_REQUESTED);
	}
*/
	Request("Dock", "ALL");
	Request("Tabs", "COMMON");
	tabview -> Select((int32)0);
}

void PWindow::MessageReceived(BMessage *msg)
{
	BMessage reply(B_SET_PROPERTY);
	switch (msg -> what)
	{
		case DOCK_AUTO_HIDE:
		{
			reply.AddSpecifier("AutoHide");
			if (dockautohide -> Value() == B_CONTROL_ON)
			{
				reply.AddBool("data", true);
				dockdelaytime -> SetEnabled(true);
			}
			else if (dockautohide -> Value() == B_CONTROL_OFF)
			{
				reply.AddBool("data", false);
				dockdelaytime -> SetEnabled(false);
			}
			Put(&reply);
			break;
		}
		case DOCK_DELAY_TIME:
		{
			reply.AddSpecifier("HideEffectDelay");
			reply.AddInt32("data", (int32) dockdelaytime -> Value() * 200000);
			Put(&reply);
			break;
		}
		case DOCK_POSITION_TOP:
		{
			BString position("top");
			reply.AddSpecifier("DockLocation");
			reply.AddString("data", position);
			Put(&reply);
			break;
		}
		case DOCK_POSITION_BOTTOM:
		{
			BString position("bottom");
			reply.AddSpecifier("DockLocation");
			reply.AddString("data", position);
			Put(&reply);
			break;
		}
		case DOCK_POSITION_LEFT:
		{
			BString position("left");
			reply.AddSpecifier("DockLocation");
			reply.AddString("data", position);
			Put(&reply);
			break;
		}
		case DOCK_POSITION_RIGHT:
		{
			BString position("right");
			reply.AddSpecifier("DockLocation");
			reply.AddString("data", position);
			Put(&reply);
			break;
		}
		case DOCK_COLOR:
		{
			rgb_color currentcolor = dockcolorctrl -> ValueAsColor();
			reply.AddSpecifier("BackColor");
			reply.AddData("data", B_RGB_COLOR_TYPE, &currentcolor, sizeof(currentcolor));
			Put(&reply);
			break;
		}
		case DOCK_TRANSPARENT_MENUS:
		{
			bool flag = docktransparentmenus -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("TransparentMenus");
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		case DOCK_DRAW_OUTER_FRAME:
		{
			bool flag = dockdrawouterframe -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("DrawOuterFrame");
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		case DOCK_ALWAYS_ON_TOP:
		{
			bool flag = dockalwaysontop -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("AlwaysOnTop");
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		case DOCK_HIDE_STD_DESKBAR:
		{
			bool flag = dockhidestddeskbar -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("HideStandardDeskbar");
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		case DOCK_USE_WINDOW_SHAPPING:
		{
			bool flag = dockusewindowshapping -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("UseWindowShapping");
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		case TAB_COLOR:
		{
			rgb_color currentcolor = tabcolorctrl -> ValueAsColor();
			currentcolor.alpha = 255;
			
			if (tabsamecolor -> Value() == B_CONTROL_ON)
			{
				for (int32 i = 0; i < tabcount; i++)
				{
					BMessage reply(B_SET_PROPERTY);
					reply.AddSpecifier("FrameColor");
					reply.AddSpecifier("tab", i);
					reply.AddData("data", B_RGB_COLOR_TYPE, &currentcolor, sizeof(currentcolor));
					Put(&reply);
				}
				break;
			}
			else
			{
				int32 index = tablistview -> CurrentSelection();

				reply.AddSpecifier("FrameColor");
				reply.AddSpecifier("tab", index);
				reply.AddData("data", B_RGB_COLOR_TYPE, &currentcolor, sizeof(currentcolor));
				Put(&reply);
			}
			break;
		}
		case TAB_SAME_COLOR:
		{
			if (tabsamecolor -> Value() == B_CONTROL_ON)
			{
				tabcolorctrl -> SetEnabled(true);
				tabcolorctrl -> SetValue(TabFetchColor(0));
				
			}
			else
			{
				if (tablistview -> CurrentSelection() < 0)
				{
					tabcolorctrl -> SetEnabled(false);
					tabcolorctrl -> SetValue((rgb_color) {0, 0, 0, 255});
				}
			}
			break;
		}
		case TAB_AUTO_HIDE:
		{
			break;
		}
		case TAB_LISTITEM_INVOKED:
		{
			break;
		}
		case TAB_LISTITEM_SELECTED:
		{
			if (tablistview -> CurrentSelection()  < 0)
			{
				if (tabsamecolor -> Value() != B_CONTROL_ON)
				{
					tabcolorctrl -> SetValue((rgb_color) {0, 0, 0, 255});
					tabcolorctrl -> SetEnabled(false);
				}
				tabtextentry -> SetEnabled(false);
				tabtextentry -> SetText("");
				tabautohide -> SetEnabled(false);
				tabcpuusagebar -> SetEnabled(false);
				tabalphahandles -> SetEnabled(false);
				remove_tab -> SetEnabled(false);
			}
			else
			{
				int32 index = tablistview -> CurrentSelection();
				
				tabcolorctrl -> SetEnabled(true);
				tabtextentry -> SetEnabled(true);
				tabautohide -> SetEnabled(true);
				remove_tab -> SetEnabled(true);
				
				tabcpuusagebar -> SetEnabled(true);
				if (TabFetchCpuBars(index)) tabcpuusagebar -> SetValue(B_CONTROL_ON);
				else tabcpuusagebar -> SetValue(B_CONTROL_OFF);
				
				tabalphahandles -> SetEnabled(true);
				if (TabFetchAlphaHandles(index)) tabalphahandles -> SetValue(B_CONTROL_ON);
				else tabalphahandles -> SetValue(B_CONTROL_OFF);
				
				PListItem *current_item;
				current_item = (PListItem*) tablistview -> ItemAt(index);
				tabtextentry -> SetText(current_item -> Name().String());
				
				if (TabFetchAutoHide(index)) tabautohide -> SetValue(B_CONTROL_ON);
				else tabautohide -> SetValue(B_CONTROL_OFF);
				
				if (tabsamecolor -> Value() != B_CONTROL_ON)
				{
					tabcolorctrl -> SetValue(TabFetchColor(index));
				}
				
			}
			break;
		}
		case TAB_NAME_CHANGED:
		{
			int32 index = tablistview -> CurrentSelection();
			PListItem *current_item;
			current_item = (PListItem*) tablistview -> ItemAt(index);
			current_item -> SetName(tabtextentry -> Text());
			tablistview -> InvalidateItem(index);
			reply.AddSpecifier("Name");
			reply.AddSpecifier("tab", index);
			reply.AddString("data", tabtextentry -> Text());
			Put(&reply);
			break;
		}
		case TAB_CREATE_TAB:
		{
			BMessage msg(B_CREATE_PROPERTY);
			msg.AddSpecifier("tab");
			//msg.AddInt32( "index", index );
			Put(&msg);
			
			tabcount++;
			BString name = TabFetchName(tabcount - 1);
			tablistview -> AddItem(new PListItem(name));
			break;
		}
		case TAB_REMOVE_TAB:
		{
			BAlert *alert = new BAlert("Question", "Do you really want to delete this tab?", "Yes", "No" );
			int32 answere = alert -> Go();
			if (answere != 0) break;
			tabcount--;
			int32 index = tablistview -> CurrentSelection();
			BMessage msg(B_DELETE_PROPERTY);
			msg.AddSpecifier("tab", index );
			Put(&msg);
			tablistview -> RemoveItem(index);
			break;
		}
		
		case TAB_CPU_USAGE_BAR:
		{
			bool flag = tabcpuusagebar -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("DrawCpuUsageBars");
			reply.AddSpecifier("tab", tablistview -> CurrentSelection());
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		case TAB_ALPHA_HANDLES:
		{
			bool flag = tabalphahandles -> Value() == B_CONTROL_ON;
			reply.AddSpecifier("DoAlphaBlendedActiveHandles");
			reply.AddSpecifier("tab", tablistview -> CurrentSelection());
			reply.AddBool("data", flag);
			Put(&reply);
			break;
		}
		default:
		{
			return;
		}
	}
}

void PWindow::Request(char *target, char *what, int32 index = -1)
{
	bool result;
	
	if (what == "ALL" && target == "Dock")
	{
		Fetch(target, "AutoHide");
		Fetch(target, "BackColor");
		Fetch(target, "HideEffectDelay");
		Fetch(target, "AlwaysOnTop");
		Fetch(target, "DockLocation");
		Fetch(target, "DrawOuterFrame");
		Fetch(target, "TransparentMenus");
		Fetch(target, "HideStandardDeskbar");
		Fetch(target, "UseWindowShapping" );
	}
	else if (what == "COMMON" && target == "Tabs")
	{
		Fetch(target, "CountTabs");
		Fetch(target, "TabSameColor");
	}
	else result = Fetch(target, what);
}

bool PWindow::Fetch(char *target, char *what, int32 index = -1)
{
	BMessage request, reply;
	int32 error;
	
	if (target == "Tabs" && what == "CountTabs")
	{
		request.what = B_COUNT_PROPERTIES;
	}
	else request.what = B_GET_PROPERTY;
	
	if (target == "Tabs")
	{
		if (index >= 0)
		{
			request.AddSpecifier("tab", index);
		}
		else if (what == "CountTabs")
		{
			request.AddSpecifier("tabs");
		}
	}
	else if (target == "Dock") 	request.AddSpecifier(what);
	
	request.AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(&request, &reply);
	reply.FindInt32("error", &error);
	if (error != B_OK)
	{
		cout << "error retrieving " << what << " settings\n"; 
		reply.PrintToStream();
		return false;
	}
	else
	{
		Apply(target, what, reply, index);
		return true;
	}
}

void PWindow::Apply(char *target, char *what, BMessage reply, int32 index = -1)
{
	if (target == "Dock")
	{
		if (what == "AutoHide")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) dockautohide -> SetValue(B_CONTROL_ON);
			else dockautohide -> SetValue(B_CONTROL_OFF);
			dockdelaytime -> SetEnabled(response);
			return;
		}
		else if (what == "BackColor")
		{
			ssize_t size;
			rgb_color *colorp;
			reply.FindData("response",  B_RGB_COLOR_TYPE, (const void**) &colorp, &size );
			rgb_color color = *colorp;
			dockcolorctrl -> SetValue(color);
			return;
		}
		else if (what == "HideEffectDelay")
		{
			int32 response;
			reply.FindInt32("response", &response);
			dockdelaytime -> SetValue((int32) response / 200000.0);
			return;
		}
		else if (what == "AlwaysOnTop")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) dockalwaysontop -> SetValue(B_CONTROL_ON);
			else dockalwaysontop -> SetValue(B_CONTROL_OFF);
			return;
		}
		else if (what == "DockLocation")
		{
			BString response;
			reply.FindString("response", &response);
			if (response.Compare("top") == 0) dockpostop -> SetValue(1);
			else if (response.Compare("bottom") == 0) dockposbottom -> SetValue(1);
			else if (response.Compare("left") == 0) dockposleft -> SetValue(1);
			else if (response.Compare("right") == 0) dockposright -> SetValue(1);
			return;
		}
		else if (what == "DrawOuterFrame")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) dockdrawouterframe -> SetValue(B_CONTROL_ON);
			else dockdrawouterframe -> SetValue(B_CONTROL_OFF);
			return;
		}
		else if (what == "TransparentMenus")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) docktransparentmenus -> SetValue(B_CONTROL_ON);
			else docktransparentmenus -> SetValue(B_CONTROL_OFF);
			return;
		}
		else if (what == "HideStandardDeskbar")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) dockhidestddeskbar -> SetValue(B_CONTROL_ON);
			else dockhidestddeskbar -> SetValue(B_CONTROL_OFF);
			return;
		}
		else if (what == "UseWindowShapping")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) dockusewindowshapping -> SetValue(B_CONTROL_ON);
			else dockusewindowshapping -> SetValue(B_CONTROL_OFF);
			return;
		}
	}
	else if (target == "Tabs")
	{
		if (what == "CountTabs")
		{
			reply.FindInt32("response", &tabcount);
			FillList(tabcount);
		}
		else if (what == "TabSameColor")
		{
			bool response;
			reply.FindBool("response", &response);
			if (response) tabsamecolor -> SetValue(B_CONTROL_ON);
			else tabsamecolor -> SetValue(B_CONTROL_OFF);
		}
	}
	else reply.PrintToStream();
}

void PWindow::FillList(int32 count)
{
	for (int i = 0;  i < count; i++)
	{
		BString name = TabFetchName(i);
		tablistview -> AddItem(new PListItem(name));
	}
}

BString PWindow::TabFetchName(int32 index)
{
	BMessage request, reply;
	int32 error;
	
	request.what = B_GET_PROPERTY;
	request.AddSpecifier("Name");
	request.AddSpecifier("tab", index);
	request.AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(&request, &reply);
	reply.FindInt32("error", &error);
	if (error == B_OK)
	{
		BString name;
		reply.FindString("response", &name);
		return name;
	}
	else return "{error fetching name}";
}

bool PWindow::TabFetchAutoHide(int32 index)
{
	BMessage request, reply;
	int32 error;
	
	request.what = B_GET_PROPERTY;
	request.AddSpecifier("AutoHide");
	request.AddSpecifier("tab", index);
	request.AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(&request, &reply);
	reply.FindInt32("error", &error);
	if (error == B_OK)
	{
		bool flag;
		reply.FindBool("response", &flag);
		return flag;
	}
	else return false;
}

bool PWindow::TabFetchCpuBars(int32 index)
{
	BMessage request, reply;
	int32 error;
	
	request.what = B_GET_PROPERTY;
	request.AddSpecifier("DrawCpuUsageBars");
	request.AddSpecifier("tab", index);
	request.AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(&request, &reply);
	reply.FindInt32("error", &error);
	if (error == B_OK)
	{
		bool flag;
		reply.FindBool("response", &flag);
		return flag;
	}
	else return false;
}

bool PWindow::TabFetchAlphaHandles(int32 index)
{
	BMessage request, reply;
	int32 error;
	
	request.what = B_GET_PROPERTY;
	request.AddSpecifier("DoAlphaBlendedActiveHandles");
	request.AddSpecifier("tab", index);
	request.AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(&request, &reply);
	reply.FindInt32("error", &error);
	if (error == B_OK)
	{
		bool flag;
		reply.FindBool("response", &flag);
		cout << flag << "\n";
		return flag;
	}
	else return false;
}

rgb_color PWindow::TabFetchColor(int32 index)
{
	BMessage request, reply;
	int32 error;
	
	request.what = B_GET_PROPERTY;
	request.AddSpecifier("FrameColor");
	request.AddSpecifier("tab", index);
	request.AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(&request, &reply);
	reply.FindInt32("error", &error);
	if (error == B_OK)
	{
		ssize_t size;
		rgb_color *colorp;
		reply.FindData("response",  B_RGB_COLOR_TYPE, (const void**) &colorp, &size );
		rgb_color color = *colorp;
		return color;
	}
	else return (rgb_color) {0, 0, 0, 255};
}

bool PWindow::Put(BMessage *request)
{
	BMessage reply;
	int32 error;
	request -> AddSpecifier("Window", "Dock");
	BMessenger("application/x-vnd.Be-TSKB").SendMessage(request, &reply);
	reply.FindInt32("error", &error);
	if (error != B_OK) {cout << "error putting settings\n"; reply.PrintToStream(); return false;}
	else return true;

}

bool PWindow::QuitRequested()
{
	be_app -> PostMessage(B_QUIT_REQUESTED);
	return true;
}